﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win.UltraWinSchedule.TimelineView;

namespace WS_SquareCornersAppointments
{
    class CustomCreationFilter : IUIElementCreationFilter
    {
        private UltraTimelineView ultraTimelineView1;

        public CustomCreationFilter(UltraTimelineView ultraTimelineView1)
        {
            this.ultraTimelineView1 = ultraTimelineView1;
        }

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is ActivityAreaUIElement)
            {
                var appointmentElements = parent.ChildElements.OfType<AppointmentUIElement>().ToList();

                foreach (AppointmentUIElement appointmentElement in appointmentElements)
                {
                    var startTimeVisible = appointmentElement.Appointment.StartDateTime 
                        > ultraTimelineView1.VisibleDateTimeRange.StartDateTime;
                    var endTimeVisible = appointmentElement.Appointment.EndDateTime < 
                        ultraTimelineView1.VisibleDateTimeRange.EndDateTime;

                    SquareAppointmentUIElement newElement =
                        SquareAppointmentUIElement.FromAppointmentUIElement(appointmentElement,
                        startTimeVisible, endTimeVisible);

                    parent.ChildElements.Remove(appointmentElement);
                    parent.ChildElements.Add(newElement);
                }

            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
